<template>
  <div class="uc-form-element w-full">
    <div class="uc-row justify-between">
      <label
        :for="name"
        :class="{
          error: hasValidationError(),
        }"
        >{{ label }}</label
      >
      <div v-if="hasValidationError()" class="error-caption">
        {{ getValidationErrors() }}
      </div>
    </div>

    <v-select
      :id="name"
      :label="optionTextField"
      :placeholder="placeholder"
      :options="selectOptions"
      :reduce="reduce"
      :searchable="false"
      :clearable="false"
      :loading="isLoading"
      :value="modelValue"
      :multiple="multiple"
      @update:model-value="$emit('update:modelValue', $event)"
      class="uc-form-select-input"
      :class="{
        'uc-form-select-input-invalid': hasValidationError(),
      }"
      @open="$emit('open')"
      @close="onBlur"
      :required="isRequired"
    />
  </div>
</template>

<script>
import { helpers, requiredIf } from '@vuelidate/validators'
import AnalyticsService from '@/services/AnalyticsService'
import { useInputValidation } from '@/composables/InputValidation'

export default {
  props: {
    blurEvent: {
      type: String,
    },
    multiple: {
      type: Boolean,
      default: false,
    },
    getSelectOptions: {
      type: Function,
      required: true,
    },
    isRequired: {
      type: Boolean,
      default: true,
    },
    label: {
      type: String,
    },
    name: {
      type: String,
    },
    optionTextField: {
      type: String,
    },
    placeholder: {
      type: String,
    },
    reduce: {
      type: Function,
    },
    modelValue: {
      type: [String, Number, Array],
    },
  },
  emits: ['update:modelValue', 'open', 'close'],

  async created() {
    this.isLoading = true
    this.selectOptions = await this.getSelectOptions()
    this.isLoading = false
  },

  setup() {
    const { v$, hasValidationError, getValidationErrors } = useInputValidation()
    return { v$, hasValidationError, getValidationErrors }
  },

  data() {
    return {
      hasSelectedOption: false,
      isLoading: false,
      selectOptions: [],
    }
  },

  validations() {
    return {
      modelValue: {
        required: helpers.withMessage('Required', requiredIf(this.isRequired)),
      },
    }
  },

  methods: {
    onBlur() {
      this.$emit('close')
      this.v$.modelValue.$touch()
      if (this.modelValue && !this.hasSelectedOption && this.blurEvent) {
        AnalyticsService.captureEvent(this.blurEvent)
        this.hasSelectedOption = true
      }
    },
  },
}
</script>
